function getSelectedText() {
  var txtarea = document.forms[0].answerText;

  // IE
  if (document.selection) {
    return document.selection.createRange().text;
  // Mozilla
  } else if (txtarea.selectionStart || txtarea.selectionStart == 0) {
    return txtarea.value.substring(txtarea.selectionStart, txtarea.selectionEnd);
  // All others
  } else {
    return "";
  }
}

function insertText(tagOpen, tagClose, selectedText) {
  var txtarea = document.forms[0].answerText;

  // IE
  if (document.selection) {
    txtarea.focus();

    document.selection.createRange().text = tagOpen + selectedText + tagClose;
  // Mozilla
  } else if (txtarea.selectionStart || txtarea.selectionStart == 0) {
    var startPos = txtarea.selectionStart;
    var endPos = txtarea.selectionEnd;
    var scrollTop = txtarea.scrollTop;

    txtarea.value = txtarea.value.substring(0, startPos) + tagOpen + selectedText + tagClose + txtarea.value.substring(endPos, txtarea.value.length);
    txtarea.focus();

    var cPos = startPos + (tagOpen.length + selectedText.length + tagClose.length);

    txtarea.selectionStart = cPos;
    txtarea.selectionEnd = cPos;
    txtarea.scrollTop = scrollTop;
  // All others
  } else {
    txtarea.value += tagOpen + selectedText + tagClose;
    txtarea.focus();
  }
}

function setEmail() {
  var selectedText = getSelectedText();

  var emailId = prompt("Email address (should not be blank)", selectedText);

  if (emailId != "" && emailId != null) {
    insertText("[email]", "[/email]", emailId);
  }
}

function setFgColor() {
  var selectedText = getSelectedText();

  var color = prompt("Color (ex:- '#FF0000' or 'red')");

  if (color != "" && color != null) {
    insertText("[color="+color+"]", "[/color]", selectedText);
  }
}

function setImage() {
  var selectedText = getSelectedText();

  var imgURL = prompt("Image URL (should not be blank)", selectedText);

  if (imgURL != "" && imgURL != null) {
    insertText("[img]", "[/img]", imgURL);
  }
}

function setImageLink() {
  var selectedText = getSelectedText();

  var imgURL = prompt("Image URL (should not be blank)", selectedText);
  var linkURL = prompt("Link URL (should not be blank)", selectedText);

  if (imgURL != "" && imgURL != null && linkURL != "" && linkURL != null) {
    insertText("[url="+linkURL+"][img]", "[/img][/url]", imgURL);
  }
}

function setLink() {
  var selectedText = getSelectedText();

  var linkURL = prompt("URL (should not be blank)", selectedText);
  var linkTitle = prompt("Title (can be blank)", selectedText);

  if (linkURL != "" && linkURL != null) {
    if (linkTitle != "" && linkTitle != null) {
      insertText("[url="+linkURL+"]", "[/url]", linkTitle);
    } else {
      insertText("[url]", "[/url]", linkURL);
    }
  }
}

function setStyle(styleType) {
  if (styleType == "b" || styleType == "i" || styleType == "u") {
    insertText("["+styleType+"]", "[/"+styleType+"]", getSelectedText());
  }
}

function storeCaret(ele) {
  if (ele.createTextRange) ele.caretPos = document.selection.createRange().duplicate();
}